using System;
using System.Collections.Generic;
using System.Text;
using Interfaces;
using System.Workflow;
using System.Workflow.Runtime;
using System.Workflow.Activities;
using System.ServiceModel;

namespace BasicWCFHost
{
    [ServiceBehavior(InstanceContextMode = InstanceContextMode.Single, ConcurrencyMode = ConcurrencyMode.Multiple)]
    class WorkflowService : IWorkflows
    {
        public WorkflowService()
        {
            // constructor
            // add any local services we need
            ExternalDataExchangeService dataEx = new ExternalDataExchangeService();
            workflowRuntime.AddService(dataEx);
            dataEx.AddService(waitForMessage);


        }

#region IWorkflows Members

        public static WorkflowRuntime workflowRuntime = new WorkflowRuntime();
        public static WaitForMessage waitForMessage = new WaitForMessage();


        public void FireOffWorkflow(string s)
        {
            Dictionary<string, object> param = new Dictionary<string, object>();
            param.Add("ValueToPrint", s);

            WorkflowInstance wi = workflowRuntime.CreateWorkflow(typeof(BasicWCFHostedWorkflow.FireAndForget), param);
            wi.Start();
        }

        #endregion

        #region IWorkflows Members


        public void StartWorkflow(Guid id, string s)
        {
            Dictionary<string, object> param = new Dictionary<string, object>();
            param.Add("ValueToPrint", s);

            WorkflowInstance wi = workflowRuntime.CreateWorkflow(typeof(BasicWCFHostedWorkflow.InteractionWorkflow), param, id);
            wi.Start();
        }

        public void SendMessage(Guid id, string s)
        {
            waitForMessage.MessageReceived(id, s);
        }

        #endregion
    }
}
