#region Using directives

using System;
using System.Collections.Generic;
using System.Text;
using System.Threading;
using System.Workflow.Runtime;
using System.Workflow.Runtime.Hosting;

#endregion

namespace WorkflowClient
{
    class Program
    {
        static void Main(string[] args)
        {
            Console.WriteLine("Press <ENTER> to begin");
            Console.ReadLine();
            using(WorkflowRuntime workflowRuntime = new WorkflowRuntime())
            {
                AutoResetEvent waitHandle = new AutoResetEvent(false);
                workflowRuntime.WorkflowCompleted += delegate(object sender, WorkflowCompletedEventArgs e) {waitHandle.Set();};
                workflowRuntime.WorkflowTerminated += delegate(object sender, WorkflowTerminatedEventArgs e)
                {
                    Console.WriteLine(e.Exception.Message);
                    waitHandle.Set();
                };
                Dictionary<string, object> param = new Dictionary<string, object>();
                param.Add("StringToSend", "ALongStringWithAFewDifferentCapsInIt");
                WorkflowInstance instance = workflowRuntime.CreateWorkflow(typeof(WorkflowClient.Workflow1), param);
                instance.Start();

                waitHandle.WaitOne();
                Console.WriteLine("Press <ENTER> to exit");
                Console.ReadLine();
            }
        }
    }
}
