using System;

namespace Microsoft.ServiceModel.Samples.SecurityTokenService.Constants
{
    public static class Numbers
    {
        public const string TwoThousandFortyEight = "2048";
    }
}
namespace Microsoft.ServiceModel.Samples.SecurityTokenService.Constants.WSIdentity
{
    public static class NamespaceUri
    {
        public const string Uri = "http://schemas.xmlsoap.org/ws/2005/05/identity";
        public const string Prefix = "wsid";
    }

    public static class Elements
    {
        public const string InformationCardReference = "InformationCardReference";
        public const string RequestDisplayToken = "RequestDisplayToken";
        public const string ClientPseudonym = "ClientPseudonym";
    }

    public static class KeyTypes
    {
        public const string NoProofKey = "http://schemas.xmlsoap.org/ws/2005/05/identity/NoProofKey";
    }
}

namespace Microsoft.ServiceModel.Samples.SecurityTokenService.Constants.Saml
{
    public static class AuthenticationMethods
    {
        public const string Unspecified = "urn:oasis:namespace:tc:SAML:1.0:am:unspecified";
    }
}

namespace Microsoft.ServiceModel.Samples.SecurityTokenService.Constants.XmlEnc
{
    public static class Algorithms
    {
        public const string RsaOaepMgf1p = "http://www.w3.org/2001/04/xmlenc#rsa-oaep-mgf1p";
    }

}

namespace Microsoft.ServiceModel.Samples.SecurityTokenService.Constants.XmlDSig
{
    public static class NamespaceUri
    {
        public const string Uri = "http://www.w3.org/2000/09/xmldsig#";
    }

    public static class Algorithms
    {
        public const string RsaSha1 = "http://www.w3.org/2000/09/xmldsig#rsa-sha1";
    }
}

namespace Microsoft.ServiceModel.Samples.SecurityTokenService.Constants.XmlCanonicalization
{
    public static class Algorithms
    {
        public const string ExcC14n = "http://www.w3.org/2001/10/xml-exc-c14n#";
    }
}

namespace Microsoft.ServiceModel.Samples.SecurityTokenService.Constants.WSTrust
{
    public static class NamespaceUri
    {
        public const string Uri = "http://schemas.xmlsoap.org/ws/2005/02/trust";
        public const string Prefix = "t";
    }

    public static class Actions
    {
        public const string Issue = "http://schemas.xmlsoap.org/ws/2005/02/trust/RST/Issue";
        public const string IssueResponse = "http://schemas.xmlsoap.org/ws/2005/02/trust/RSTR/Issue";

        public const string Renew = "http://schemas.xmlsoap.org/ws/2005/02/trust/RST/Renew";
        public const string RenewResponse = "http://schemas.xmlsoap.org/ws/2005/02/trust/RSTR/Renew";

        public const string Validate = "http://schemas.xmlsoap.org/ws/2005/02/trust/RST/Validate";
        public const string ValidateResponse = "http://schemas.xmlsoap.org/ws/2005/02/trust/RSTR/Validate";

        public const string Cancel = "http://schemas.xmlsoap.org/ws/2005/02/trust/RST/Cancel";
        public const string CancelResponse = "http://schemas.xmlsoap.org/ws/2005/02/trust/RSTR/Cancel";
    }

    public static class Attributes
    {
        public const string Context = "Context";
        public const string Type = "Type";
    }

    public static class Elements
    {
        public const string EncryptWith = "EncryptWith";
        public const string Lifetime = "Lifetime";
        public const string Claims = "Claims";
        public const string KeyType = "KeyType";
        public const string KeySize = "KeySize";
        public const string RequestType = "RequestType";
        public const string RequestSecurityTokenResponse = "RequestSecurityTokenResponse";
        public const string RequestSecurityToken = "RequestSecurityToken";
        public const string RequestedSecurityToken = "RequestedSecurityToken";
        public const string RequestedAttachedReference = "RequestedAttachedReference";
        public const string RequestedUnattachedReference = "RequestedUnattachedReference";
        public const string SignWith = "SignWith";
        public const string TokenType = "TokenType";
        public const string UseKey = "UseKey";
        public const string CanonicalizationAlgorithm = "CanonicalizationAlgorithm";
    }

    public static class RequestTypes
    {
        public const string Issue = "http://schemas.xmlsoap.org/ws/2005/02/trust/Issue";
    }

    public static class TokenTypes
    {
        // public static readonly string Saml11Assertion = "http://docs.oasis-open.org/wss/oasis-wss-saml-token-profile-1.1#SAMLV1.1";
        public const string Saml10Assertion = "urn:oasis:names:tc:SAML:1.0:assertion";
    }

    public static class KeyTypes
    {
        public const string Asymmetric = "http://schemas.xmlsoap.org/ws/2005/02/trust/PublicKey";
    }
}
