using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Configuration;
using System.IdentityModel.Claims;
using System.IdentityModel.Tokens;
using System.ServiceModel;
using System.Text;

namespace SecurityTokenService
{
    [ServiceBehavior(IncludeExceptionDetailInFaults = true)]
    public class ConcreteSecurityTokenService: SecurityTokenService
    {
        public ConcreteSecurityTokenService():base( ConfigurationManager.AppSettings["SecurityTokenServiceName"],FederationUtility.GetX509TokenFromCert(ServiceConstants.PersonalCertificateStore, ServiceConstants.CertificateStoreLocation, ConfigurationManager.AppSettings["IssuerCertificateIdentifier"]),FederationUtility.GetX509TokenFromCert(ServiceConstants.PersonalCertificateStore, ServiceConstants.CertificateStoreLocation, ConfigurationManager.AppSettings["ProofKeyCertificateIdentifier"]))
        {
        }

        protected override Collection<SamlAttribute> GetIssuedClaims(RequestSecurityToken rst)
        {
            Collection<SamlAttribute> samlAttributes = new Collection<SamlAttribute>();
            List<Claim> claims = new List<Claim>();
            foreach(ClaimSet claimSet in ServiceSecurityContext.Current.AuthorizationContext.ClaimSets)
            {
                foreach(Claim claim in claimSet)
                {
                    if(claim.Right == Rights.PossessProperty)
                    {
                        claims.Add(claim);
                    }
                }
            }
            if(claims.Count <= 0)
            {
                claims.Add(new DefaultClaimSet(ClaimSet.System,new Claim[]{ new Claim("Role","Anonymous",Rights.PossessProperty)})[0]);
            }
            foreach(Claim claim in claims)
            {
                samlAttributes.Add(new SamlAttribute(claim.ClaimType.Substring(0, claim.ClaimType.LastIndexOf('/') + 1), claim.ClaimType.Substring(claim.ClaimType.LastIndexOf('/') + 1), new string[] { claim.Resource.ToString() }));
            }



            return samlAttributes;
        }
	
    }
}
