using System;
using System.Collections.Generic;
using System.ServiceModel.Channels;
using System.ServiceModel.Description;
using System.ServiceModel.Dispatcher;
using System.Text;

namespace Extensibility
{
	public class MyMessageInspector: IClientMessageInspector, IEndpointBehavior
	{
        private string myProperty = null;

        public MyMessageInspector(string myProperty)
        {
            this.myProperty = myProperty;
        }

		#region IEndpointBehavior Members

		public void AddBindingParameters(ServiceEndpoint serviceEndpoint, BindingParameterCollection bindingParameters)
		{
		}

		public void ApplyClientBehavior(ServiceEndpoint serviceEndpoint, ClientRuntime behavior)
		{
            
			behavior.MessageInspectors.Add(this);
		}

		public void ApplyDispatchBehavior(ServiceEndpoint serviceEndpoint, EndpointDispatcher endpointDispatcher)
		{
            
		}

		public void Validate(ServiceEndpoint serviceEndpoint)
		{
		}

		#endregion

		#region IClientMessageInspector Members

		public void AfterReceiveReply(ref System.ServiceModel.Channels.Message reply, object correlationState)
		{
			Console.WriteLine("I am playing games with the response message before it is processed.");
		}

		public object BeforeSendRequest(ref System.ServiceModel.Channels.Message request, System.ServiceModel.IClientChannel channel)
		{
			Console.WriteLine("I am playing games with the request message before it is sent.");
            Console.WriteLine("My property value is {0}.",this.myProperty);
			return null;
		}

		#endregion
	}
}
