using System;
using System.Collections.Generic;
using System.ServiceModel.Description;
using System.ServiceModel.Dispatcher;
using System.Text;

namespace Extensibility
{
    public class MyInstanceContextProvider : IInstanceContextProvider, IEndpointBehavior
	{
        private IInstanceContextProvider defaultInstanceContextProvider = null;

		#region IEndpointBehavior Members

		public void AddBindingParameters(ServiceEndpoint serviceEndpoint, System.ServiceModel.Channels.BindingParameterCollection bindingParameters)
		{
		}

		public void ApplyClientBehavior(ServiceEndpoint serviceEndpoint, ClientRuntime behavior)
		{
			
		}

		public void ApplyDispatchBehavior(ServiceEndpoint serviceEndpoint, EndpointDispatcher endpointDispatcher)
		{
            this.defaultInstanceContextProvider = endpointDispatcher.DispatchRuntime.InstanceContextProvider;
            endpointDispatcher.DispatchRuntime.InstanceContextProvider = this;
		}

		public void Validate(ServiceEndpoint serviceEndpoint)
		{
		}

		#endregion



        #region IInstanceContextProvider Members

        public System.ServiceModel.InstanceContext GetExistingInstanceContext(System.ServiceModel.Channels.Message message, System.ServiceModel.IContextChannel channel)
        {
            Console.WriteLine("Retrieving the instance context.");
            return this.defaultInstanceContextProvider.GetExistingInstanceContext(message, channel);
        }

        public void InitializeInstanceContext(System.ServiceModel.InstanceContext instanceContext, System.ServiceModel.Channels.Message message, System.ServiceModel.IContextChannel channel)
        {
            this.defaultInstanceContextProvider.InitializeInstanceContext(instanceContext, message, channel);
        }

        public bool IsIdle(System.ServiceModel.InstanceContext instanceContext)
        {
            Console.WriteLine("Persisting the instance context.");
            return this.defaultInstanceContextProvider.IsIdle(instanceContext);
        }

        public void NotifyIdle(InstanceContextIdleCallback callback, System.ServiceModel.InstanceContext instanceContext)
        {
            this.defaultInstanceContextProvider.NotifyIdle(callback, instanceContext);
        }

        #endregion
    }
}
