using System;
using System.Collections.Generic;
using System.ServiceModel;
using System.ServiceModel.Channels;
using System.ServiceModel.Description;
using System.Text;

namespace Extensibility
{
    public class Program
    {
        static void Main(string[] args)
        {
			using (ServiceHost host = new ServiceHost(typeof(Service), new Uri[]{new Uri("http://localhost:8000/SimpleService"),new Uri("net.tcp://localhost:8001/SimpleService")}))
			{
                ServiceMetadataBehavior metadataBehavior = new ServiceMetadataBehavior();
                metadataBehavior.HttpGetEnabled = true;
                host.Description.Behaviors.Add(metadataBehavior);

				host.AddServiceEndpoint(typeof(ISimple), new CustomBinding(new HttpTransportBindingElement()), "Endpoint");

				host.Description.Endpoints[0].Behaviors.Add(new MyMessageInspector());
                host.Description.Endpoints[0].Behaviors.Add(new MyInstanceContextProvider());
                host.Description.Endpoints[0].Behaviors.Add(new MyInstanceProvider());
				host.Description.Endpoints[0].Behaviors.Add(new MyOperationSelector());
				host.Description.Endpoints[0].Contract.Operations[0].Behaviors.Add(new MyMessageFormatter());
				host.Description.Endpoints[0].Contract.Operations[0].Behaviors.Add(new MyParameterInspector());
				host.Description.Endpoints[0].Contract.Operations[0].Behaviors.Add(new MyOperationInvoker());

				Console.WriteLine("REMEMBER THAT THE WSDL GENERATION BEHAVIOR DOES NOT WORK UNLESS YOU REQUEST THE METADATA.");
				Console.WriteLine();
				
				host.Open();

				Console.WriteLine("Service is ready.");
				Console.ReadKey(true);
			}
        }
    }
}
