using System;
using System.Collections.Generic;
using System.ServiceModel;
using System.ServiceModel.Channels;
using System.Text;

namespace Extensibility
{
    public class Program
    {
        static void Main(string[] args)
        {
			Console.WriteLine("Press any key when the service is ready.");
			Console.ReadKey(true);

            Client client = new Client(
                new CustomBinding(
                    new BindingElement[] { 
                        new MyCustomBindingElement(), 
                        new HttpTransportBindingElement() }),
                        new EndpointAddress(
                        "http://localhost:8000/SimpleService/Endpoint"));

            client.Open();

            Console.WriteLine("The client is open: press any key to continue.");
            Console.ReadKey(true);

			Console.WriteLine(client.AcceptRequest("Hello, World!"));
            Console.WriteLine(client.AcceptRequest("Hello, World!"));
            client.Close();

			Console.WriteLine("Done.");
			Console.ReadKey(true);
        }
    }
}
