using System;
using System.Collections.Generic;
using System.Text;
using System.Threading;

namespace PublicationSubscription
{
	public class RandomDataPoint: DataPoint
	{
		private Random randomNumberGenerator = null;
		private Timer valueFluctuationTimer = null;
		private int frequency;
		
		public RandomDataPoint(string name, string description, int frequency, bool activate):base(name, description)
		{
			this.frequency = frequency;

			this.randomNumberGenerator = new Random();
			
			this.Active = activate;
		}

		public bool Active
		{
			get
			{
				return this.valueFluctuationTimer != null;
			}

			set
			{
				if (value)
				{
					if (this.valueFluctuationTimer == null)
					{
						this.valueFluctuationTimer = new Timer(this.TimerCallbackHandler, null, 0, frequency);
					}
				}
				else
				{
					if (this.valueFluctuationTimer != null)
					{
						this.valueFluctuationTimer.Dispose();
						this.valueFluctuationTimer = null;
					}
				}
			}
		}

		private void TimerCallbackHandler(object state)
		{
			int newDatum = this.randomNumberGenerator.Next(100);
			Console.WriteLine("Generated datum {0}.", newDatum);
			base.RaiseNextValueEvent(this, BitConverter.GetBytes(newDatum));
		}
}
}
