using System;
using System.Collections.Generic;
using System.ServiceModel;
using System.ServiceModel.Channels;
using System.Text;

namespace Client
{
    public class ReliableHttpBinding : CustomBinding, IBindingDeliveryCapabilities
    {
        public ReliableHttpBinding()
        {
            this.Elements.Add(new ReliableSessionBindingElement(true));
            this.Elements.Add(new InterceptorBindingElement());
            this.Elements.Add(new HttpTransportBindingElement());
        }

        #region IBindingCapabilities Members

        bool IBindingDeliveryCapabilities.AssuresOrderedDelivery
        {
            get
            {
                return true;
            }
        }


        bool IBindingDeliveryCapabilities.QueuedDelivery
        {
            get
            {
                return false;
            }
        }

        #endregion
    }
}
